<template>
  <match-screen>
    <template v-if="!isLoading && pair" #status>
      <div :style="progressStyle"></div>
      <div>{{ currentNumber }} / {{ pairsCount }}</div>
    </template>
    <template v-if="!isLoading && pair" #question>
      <span>{{ pair.questionText }}</span>
    </template>
    <template v-if="!isLoading && pair" #content>
      <match-products :pair="pair" />
    </template>
    <template v-if="!isLoading && pair" #buttons>
      <like-button
        :name="pair.firstAnswerIcon"
        :colorStyle="pair.firstAnswerColor"
        @click="next(pair.firstAnswerCode)"
      />
      <like-button
        :name="pair.secondAnswerIcon"
        :colorStyle="pair.secondAnswerColor"
        @click="next(pair.secondAnswerCode)"
      />
    </template>
  </match-screen>
</template>
<script lang="ts">
import { GlobalStateSymbol, State } from "@/GlobalProvider";
import { computed, defineComponent, inject, reactive, ref, watch } from "vue";
import LikeButton from "./LikeButton.vue";
import MatchProducts from "./MatchProducts.vue";
import MatchScreen from "./MatchScreen.vue";
import { useFetchProductsApi } from "./fetchProducts";
import { useAssessProductsApi } from "./assessProducts";

export default defineComponent({
  components: {
    LikeButton,
    MatchProducts,
    MatchScreen,
  },
  setup(props) {
    const {
      isLoading,
      error,
      data,
      fetchProducts,
      globalState,
    } = useFetchProductsApi();
    const { assessProducts } = useAssessProductsApi(globalState);
    fetchProducts();

    let currentNumber = ref(0);

    const pair = computed(() => {
      if (data.value) {
        return data.value[currentNumber.value];
      } else {
        return undefined;
      }
    });

    const pairsCount = computed(() => data?.value?.length ?? 1);
    const next = (answer: number) => {
      if (!pair) return;
      assessProducts({
        answer: answer,
        firstProduct: pair?.value?.firstProduct ?? "",
        secondProduct: pair?.value?.secondProduct ?? "",
        questionCode: pair?.value?.questionCode ?? "",
      });
      currentNumber.value += 1;
    };
    const progressStyle = computed(() => ({
      width: ((100 * currentNumber.value) / pairsCount.value).toFixed(0) + "%",
      height: "10px",
      backgroundColor: "var(--reverse-color)",
    }));
    watch(currentNumber, (newValue, oldValue) => {
      if (newValue >= pairsCount.value) {
        fetchProducts();
        currentNumber.value = 0;
      }
    });

    return {
      pair,
      isLoading,
      error,
      next,
      progressStyle,
      pairsCount,
      currentNumber,
    };
  },
});
</script>
